# July 18, 2012

library(cobs)

# seeds used for 10 separate batches of 10,000 samples each 
# 29483121 
# 62222714 
# 11517779 
# 22340583 
# 77607811 
# 88947151
# 59503993 
# 9017897 
# 97219020 
# 93017080


lat		<-	1000
m		<-	5
nlat	<-	2*m*lat+1
delta	<-	1/lat
B		<-	10000
xx		<-	seq(-m, m, length.out=nlat)
H2		<-	rep(0, B)

set.seed(29483121)
pmt		<-	proc.time()
for(i in 1:B){
	
	XX 			<-	rnorm(n=nlat, mean=0, sd=1/sqrt(delta))+12*xx^2		#(*)
	CC			<-	conreg(x=xx, y=XX, convex=TRUE, verbose=FALSE)$yf	#(**)
	H2[i]		<-	CC[m*lat+1]
	print(i)
		
	}
proc.time()-pmt
write.table(H2, file="test_conreg_m5_lat1000_B10000_seed1.out")

# because of the selection in (*) of +12xx^2 and (**) convex=TRUE, the result in H2[i] is actually a sample from $\widetilde{\mathbb C}(0)$ as described in the Appendix.   To obtain samples from ${\mathbb C}(0)$ the results in H2 must be muliplied by (-1).     





