# September 15, 2012

library(logcondens)
library(ks)
library(evd)

f0tilde    <-	function(loc, yy, fhat, dy, h){sum(dnorm(yy,loc,h)*fhat)*dy}
f1tilde		<-	function(loc, yy, fhat, dy, h){sum(-(loc-yy)*dnorm(yy,loc,h)*fhat)*dy/(h^2)}
f2tilde		<-	function(loc, yy, fhat, dy, h){sum((((loc-yy)/h)^2-1)*dnorm(yy,loc,h)*fhat)*dy/(h^2)}

c2hat	<-	function(data, xx0, type, htype="hpi"){

				c2_DR		<-	"NA"
				c2_ks_hscv	<-	"NA"
				c2_ks_hlscv	<-	"NA"
				c2_ks_hpi	<-	"NA"
				c2_ks_hns	<-	"NA"
				c2_nrd		<-	"NA"
					
				spread		<-	diff(range(data))
				grid		<-	seq(min(data)-0.5*spread, max(data)+0.5*spread, length.out=2*1000)
				dy			<-	min(diff(grid))

				mle			<-	logConDens(data)
				fmle		<-	evaluateLogConDens(grid, mle, which=2)
				fhat		<-	fmle[,3]					
		
				if("DR" %in% type){
					h_DR		<-	sqrt(mle$sig^2-LocalVariance(x=mle$x,phi=mle$phi))
					f0			<-	function(loc) f0tilde(loc, grid, fhat, dy, h=h_DR)
					f0_DR		<-	unlist(lapply(xx0, f0))
					f1			<-	function(loc) f1tilde(loc, grid, fhat, dy, h=h_DR)
					f1_DR		<-	unlist(lapply(xx0, f1))
					f2			<-	function(loc) f2tilde(loc, grid, fhat, dy, h=h_DR)
					f2_DR		<-	unlist(lapply(xx0, f2))
					rm(f0,f1,f2)	
					c2_DR		<-	f0_DR*abs(f0_DR*f2_DR-(f1_DR)^2)
					c2_DR		<-	(c2_DR/24)^0.2
									
				}
					
				if("ks" %in% type){
					
					if("hscv" %in% htype){						
						h			<-	hscv(data)
						f0_ks		<-	kdde(x=data, eval.points=xx0, h=h, deriv.order=0)$estimate
						f1_ks		<-	kdde(x=data, eval.points=xx0, h=h, deriv.order=1)$estimate
						f2_ks		<-	kdde(x=data, eval.points=xx0, h=h, deriv.order=2)$estimate
						c2_ks		<-	f0_ks*abs(f0_ks*f2_ks-(f1_ks)^2)
						c2_ks_hscv	<-	(c2_ks/24)^0.2
						}

					if("hlscv" %in% htype){						
						h			<-	hlscv(data)
						f0_ks		<-	kdde(x=data, eval.points=xx0, h=h, deriv.order=0)$estimate
						f1_ks		<-	kdde(x=data, eval.points=xx0, h=h, deriv.order=1)$estimate
						f2_ks		<-	kdde(x=data, eval.points=xx0, h=h, deriv.order=2)$estimate
						c2_ks		<-	f0_ks*abs(f0_ks*f2_ks-(f1_ks)^2)
						c2_ks_hlscv	<-	(c2_ks/24)^0.2
						}

					if("hpi" %in% htype){						
						h			<-	hpi(data)
						f0_ks		<-	kdde(x=data, eval.points=xx0, h=h, deriv.order=0)$estimate
						f1_ks		<-	kdde(x=data, eval.points=xx0, h=h, deriv.order=1)$estimate
						f2_ks		<-	kdde(x=data, eval.points=xx0, h=h, deriv.order=2)$estimate
						c2_ks		<-	f0_ks*abs(f0_ks*f2_ks-(f1_ks)^2)
						c2_ks_hpi	<-	(c2_ks/24)^0.2
						}

					if("hns" %in% htype){						
						h			<-	hns(data)
						f0_ks		<-	kdde(x=data, eval.points=xx0, h=h, deriv.order=0)$estimate
						f1_ks		<-	kdde(x=data, eval.points=xx0, h=h, deriv.order=1)$estimate
						f2_ks		<-	kdde(x=data, eval.points=xx0, h=h, deriv.order=2)$estimate
						c2_ks		<-	f0_ks*abs(f0_ks*f2_ks-(f1_ks)^2)
						c2_ks_hns	<-	(c2_ks/24)^0.2
						}
					
				}
		
				if("nrd" %in% type){
					fmle		<-	evaluateLogConDens(xx0, mle, which=4)
					ftilde		<-	fmle[,5]
					c2_nrd		<-	ftilde^3/mle$sig^2					
					c2_nrd		<-	(c2_nrd/24)^0.2
									
				}
	
				return(list(DR=c2_DR, ks_hscv=c2_ks_hscv, ks_hlscv=c2_ks_hlscv, ks_hpi=c2_ks_hpi,ks_hns=c2_ks_hns, nrd=c2_nrd))
	
}

