# 	September 15, 2012
#	simulations for boxplots - example 

source("functions.R")

#--------------------------------------
#--------------------------------------
#   normal distribution, n=100

xx0		<-	seq(-3,3, length.out=500)
dx		<-	min(diff(xx0))
f0		<-	dnorm(xx0)
c2		<-	(f0^3/24)^0.2
B		<-	1000
n		<-	100

l_DR	<-	rep(0, B)
l_hscv	<-	rep(0, B)
l_hlscv	<-	rep(0, B)
l_hpi	<-	rep(0, B)
l_hns	<-	rep(0, B)
l_nrd	<-	rep(0, B)

set.seed(315919)
for(i in 1:B){
	data 		<-  rnorm(n)
	c2fit		<-	c2hat(data, xx0, type=c("DR", "ks", "nrd"), htype=c("hscv", "hpi", "hlscv", "hns"))
	l_DR[i]		<-	sum((c2-c2fit$DR)^2)*dx
	l_hscv[i]	<-	sum((c2-c2fit$ks_hscv)^2)*dx
	l_hlscv[i]	<-	sum((c2-c2fit$ks_hlscv)^2)*dx
	l_hpi[i]	<-	sum((c2-c2fit$ks_hpi)^2)*dx
	l_hns[i]	<-	sum((c2-c2fit$ks_hns)^2)*dx
	l_nrd[i]	<-	sum((c2-c2fit$nrd)^2)*dx
	print(i)
			
}

l2		<-	c(l_DR, l_hscv, l_hlscv, l_hpi, l_hns, l_nrd)
type	<-	rep(c("DR", "hscv", "hlscv", "hpi", "hns", "nrd"), each=B)
res		<-	data.frame(type, l2)
write.table(res, file="l2norm_n100.out", sep=" ")

res		<-	read.table("l2norm_n100.out")


postscript("l2norm_n100.eps", horizontal=FALSE, onefile=FALSE, height=5, width=8, pointsize=15)
pdf("l2norm_n100.pdf", onefile=FALSE, height=5, width=8, pointsize=15)

	par(pty="m", mar=rep(2,4))
	boxplot(res$l2~res$type, range=0, ylim=c(0,0.05), col=grey(0.5))

dev.off()

